package com.nsgk.agentcentersdk.api;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import lombok.Data;

// 服务端返回对象
@Data
public class NSApiResult
{
    public final int code;
    public final String msg;
    public final Object data;
    public final long timestamp = System.currentTimeMillis();

    NSApiResult(int code, String msg, Object data)
    {
        this.code = code;
        this.msg = msg;
        this.data = data;
    }

    static NSApiResult FromJSON(String str)
    {
        JSONObject jsonObject;

        jsonObject = JSON.parseObject(str);
        return new NSApiResult(jsonObject.getInteger("code"), jsonObject.getString("msg"), jsonObject.get("data"));
    }
}
