package com.nsgk.agentcentersdk.api;

import com.nsgk.agentcentersdk.core.NSReportObject;
import com.nsgk.agentcentersdk.entity.NSEntityBase;
import com.nsgk.agentcentersdk.utility.NSArr;
import com.nsgk.agentcentersdk.utility.NSCrypto;
import com.nsgk.agentcentersdk.utility.NSHttp;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

// SDK服务端
public final class NSSDKServer
{
    private final String privateKey;

    public NSSDKServer(String privateKey)
    {
        this.privateKey = privateKey;
    }

    // 解析请求
    public <T extends NSEntityBase> NSReportObject<T> Recv(HttpServletRequest request, Class<T> clazz)
    {
        NSReportObject<T> res;
        String sign;
        String data;

        sign = request.getHeader("sign");
        data = NSHttp.GetRequestBody(request);
        res = new NSReportObject<>();
        res.SetTimestampStr(request.getParameter("timestamp"))
                .setIdentifier(request.getParameter("identifier"))
                .SetProtocolStr(request.getParameter("protocol"))
                .SetDataStr(NSCrypto.RSADecrypt(data, privateKey), clazz)
        ;
        if(!res.CheckSign(sign))
        {
            return null;
        }
        res.setSign(sign);
        return res;
    }

    // 响应客户端
    public NSApiResult Resp(int code, String msg, Object...data)
    {
        return new NSApiResult(code, msg, NSArr.DefParms(data));
    }
}
