package com.nsgk.agentcentersdk.network;

import com.nsgk.agentcentersdk.core.NSReportObject;
import com.nsgk.agentcentersdk.utility.NSCrypto;
import lombok.Data;
import lombok.experimental.Accessors;

// Http请求
@Data
@Accessors(chain = true)
public class NSNetworkRequest extends NSNetworkTransport
{
    public <T> void WriteDataObject(NSReportObject<T> object, String publicKey)
    {
        String dataStr;

        ClearHeaders().AddHeader("sign", object.getSign());
        ClearQueries().AddQuery("identifier", object.getIdentifier())
                .AddQuery("protocol", object.getProtocol())
                .AddQuery("timestamp", object.getTimestamp())
        ;
        dataStr = object.getDataStr();
        setData(NSCrypto.RSAEncrypt(dataStr, publicKey));
    }
}
